/* Prgram to draw a line using Bresenhams algorithm.

   This includes to draw the line of type:
		Thick,Thin,Dashed    .   */


#include<stdio.h>
#include<conio.h>
#include<graphics.h>
#include<math.h>

/* Function prototypes */

void bres(int x1, int y1, int x2, int y2) ;
void dash(int x1, int y1, int x2, int y2) ;
void thick(int x1, int y1, int x2, int y2, int w) ;
/*---------------------------------------------------------*/

main (void)
{
int driver,mode,x1,y1,x2,y2,w;
char choice;
 driver=DETECT;
detectgraph (&driver, &mode) ;
initgraph (&driver, &mode,"") ;
clrscr() ;
printf ("\n\t Enter the co-ordinates : ") ;
gotoxy (22, 8) ;
printf ("x1 = ") ;
gotoxy (27, 8) ;
scanf ("%d", &x1) ;
gotoxy (22, 10) ;
printf ("y1 = ") ;
gotoxy (27, 10) ;
scanf ("%d", &y1) ;
gotoxy (22, 12) ;
printf ("x2 = ") ;
gotoxy (27, 12) ;
scanf ("%d", &x2) ;
gotoxy(22,14) ;
printf ("y2 = ") ;
gotoxy (27, 14 ) ;
scanf ("%d", &y2) ;
while (1)
{
printf ("n\n\t\t M E N U") ;
printf (" \n\t\t 1> Dashed line ") ;
printf (" \n\t\t 2> Thick Line ") ;
printf (" \n\t\t 3> Thin Line ") ;
printf (" \n\t\t 4> Exit ") ;
printf (" \n\n\t Enter choice  :  ") ;
choice = getch () ;
driver=DETECT ;
detectgraph (&driver, &mode) ;
initgraph (&driver,&mode,"") ;
	switch (choice)
	{
	case '1':
		clearviewport () ;
		dash (x1, y1, x2, y2) ;
		break;

	case '2':
		clearviewport () ;
		printf ("Enter width : ") ;
		scanf("%d",&w) ;
		thick (x1,y1,x2,y2,w);
		break;

	case '3' :
		clearviewport () ;
		bres (x1, y1, x2, y2) ;
		break;

	case '4' :
		exit (0) ;
		break;
	}  /* end of switch statement */

	getch ();
closegraph () ;
}
}
/* ---------------------end of main---------------------*/

void dash (int x1, int y1, int x2, int y2)
{
int x, y, temp, flag=0, e, dx, dy, i, s1, s2;

	x = x1 ;
	y = y1 ;
	dx = abs (x2-x1) ;
	dy = abs (y2-y1) ;

	s1 = x2-x1 ;  /* compute sign*/
	s2 = y2-y1 ;

	if (s1 == 0)
		s1 = 0 ;
	else
	{
	    if (s1 >0)
	    {
	     s1 = 1 ;
	    }
	    else
	    {
		s1 = -1 ;
	    }
	}

	if (s2 ==0)
	s2 = 0 ;
	else
	{
		if (s2 > 0)
		{
		   s2 = 1 ;
		}
		else
		{
		    s2 = -1 ;
		}
	}

	if (dy > dx)
	{
	  temp = dx ;
	  dx = dy ;
	  dy = temp ;
	  flag = 1;
	}

	e = 2 * dy - dx ;
	for (i=0;i<dx;i++)
	{
	if (i%5 == 0)
	   putpixel (x, y, 15) ;
	else
	   putpixel (x,y,0) ;
	while (e>=0)
	{
	if (flag == 1)
	{
	  x = x + s1 ;
	}
	else
	{
	  y = y + s2;
	}
	e = e - 2 * dx ;
	}

	if (flag==1)
	  y = y + s2 ;
	else
	{
	  x = x+s1 ;
	}
	e = e + 2 * dy ;
	}
}
/*-------------end of function dash-----------------------------*/

void bres (int x1, int y1, int x2, int y2)
{
int x, y,temp,flag=0, e, dx, dy, i, s1, s2 ;
x = x1;
y = y1;
	dx = abs (x2-x1) ;
	dy = abs (y2-y1) ;
	s1 = x2-x1 ;
	s2 = y2-y1 ;
if (s1 == 0)
s1 = 0 ;
else
{
if (s1 > 0)
{
s1 = 1 ;
}
else
{
s1 = -1 ;
}
}
if (s2 == 0)
s2 = 0;
else
{
if (s2 > 0)
{
s2 = 1 ;
}
else
{
s2 = -1 ;
}
}
if (dy > dx)
{
temp = dx ;
dx = dy ;
dy = temp ;
flag = 1 ;
}
e = 2 * dy - dx ;/* initial compesiating slope */
for (i=0; i<dx;i++)
{
putpixel (x, y, 15) ;
while (e>=0)
{
if (flag == 1)
{
x = x + s1 ;
}
else
{
y = y + s2 ;
}
e = e - 2 * dx ;
}
if (flag==1)
y = y + s2 ;
else
{
x = x+s1 ;
}
e = e + 2 * dy ;
}
}
/*--------------end of function bres--------------------*/

void thick (int x1, int y1, int x2, int y2, int w)
/* function to draw thcik line */
{
int x,y, temp, flag=0, e, dx, dy, i, s1, s2, j ;
x = x1 ;
y = y1 ;
dx = abs (x2-x1) ;
dy = abs (y2-y1) ;
s1 = x2-x1 ;
s2 = y2-y1 ;
if (s1 == 0)
s1 = 0 ;
else
{
if (s1 > 0)
{
s1 = 1 ;

}
else
{
s1 = -1 ;
}
}
if (s2 == 0)
s2 = 0 ;
else
{
if (s2 > 0)
{
s2 = 1 ;
}
else
{
s2 = -1 ;
}
}
if (dy > dx)
{
temp = dx ;
dx = dy ;
dy = temp ;
flag = 1 ;
}
e = 2 * dy - dx ;
for (i=0 ; i<dx ; i++)
{
for (j=0 ; j<w ; j++)
{
putpixel (x, y, 15) ;
putpixel (x-1, y, 15) ;
putpixel (x+1, y, 15) ;
}
while (e>=0)
{
if (flag == 1)
{
x = x + s1 ;
}
else
{
y = y + s2 ;
}
e = e - 2 * dx ;
}
if (flag==1)
y = y + s2 ;
else
{
x = x+s1 ;
}
e = e + 2 * dy ;
}
getch () ;

}

/*---------------end of function thick-----------------*/




















































































































































