/* This program is demonstrate the basic mousedrawing.
   The interupt and the services have been alreadymentioned. */

/* Functions used :
		getmousepos()  : to obtain the mouse position
		initmouse()    : to initialise the mouse
		showmouseptr() : to show the mouse position

    Input/output  :

		simply keep on moving the mouse and observe
		the x and y coordinate positions on the right side
		of the screen.

		Press left or right button of the mouse and see
		the display at the bottom of the screen.

  */

	#include<stdio.h>
	#include<graphics.h>
	#include<dos.h>
	#include<alloc.h>

	/* define a and b as register variables.
	   a will have the input settings, and
	   b has the ouput. */

	union REGS a,b;
	int midx,midy;
	char far *p1,far *p2,far *p3,far *p4;

	main()
	{
	int gd=DETECT,gm;  /* graphics initialising parameters */
	int x,y;     /* varibales to store the  x and
			      y values */
	int x1,y1,x2,y2;           /* store the object */

	int key;           /* the button pressed from the mouse...
			      Left or Right  */
	int sx,sy,tx,ty;

	
	if(initmouse()==0)
	{
	printf("\n not ");
	exit(1);
	}

	initgraph(&gd,&gm,"d:\\tc\\turboc2\\turboc2");
	gotoxy(1,1);
	printf(" Rectangle...");
	gotoxy(70,1);
	printf("Right mouse button to quit..");
	do
	{
	  showmouseptr();  /* display the current cursor position */
	  getmousepos(&key,&tx,&ty);

	  if(key & 1  == 1)
	  {
	   hidemouseptr();
	   sx=x=x1=x2=tx;
	   sy=y=y1=y2=ty;
	   setcolor(WHITE);
	   save(x1,y1,x2,y2);
	   rectangle(x1,y1,x2,y2);
	   getmousepos(&key,&tx,&ty);
	   while((key & 1) ==1)
	   {
	   if(x!=tx || y!=ty)
	   {
	   setcolor(RED);
	   rectangle(x1,y1,x2,y2);
	   restore(x1,y1);
	   x=tx;
	   y=ty;
	   if(x<sx)
	   {
	   x1=x;
	   x2=sx;
	   }
	   else
	   {
	   x1=sx;
	   x2=x;
	   }
	   if(y<sy)
	   {
	   y1=y;
	   y2=sy;
	   }
	   else
	   {
	   y1=sy;
	   y2=y;
	   }
	   setcolor(WHITE);
	   save(x1,y1,x2,y2);
	   rectangle(x1,y1,x2,y2);
	   }
	   getmousepos(&key,&tx,&ty);
	   }
	   restore(x1,y1);
	   showmouseptr();
	   }
	   }while((key&2)!=2);

	  gotoxy(1,1);
	  printf("Hit any key to exit...");

	   gotoxy(60,1);

	   printf("");
	   getch();
	   closegraph();

}
/* -------------------end of main------------------------------------*/
 save(int x1,int y1,int x2,int y2)
 {
 unsigned area1,area2,area3,area4;
 midx=x1+(x2-x1)/2;
 midy=y1+(y2-y1)/2;
 area1=imagesize(x1,y1,midx,midy);
 p1=farmalloc(area1);
 area2=imagesize(midx+1,y1,x2,midy);
 p2=farmalloc(area2);
 area3=imagesize(x1,midy+1,midx,y2);
 p3=farmalloc(area3);
area4=imagesize(midx+1,midy+1,x2,y2);
 p4=farmalloc(area4);

 if(p1==NULL||p2==NULL||p3==NULL||p4==NULL)
 {
 closegraph();
 printf("Not enough memory");
 exit(2);
 }
 getimage(x1,y1,midx,midy,p1);
 getimage(midx+1,y1,x2,midy,p2);
 getimage(x1,midy+1,midx,y2,p3);
 getimage(midx+1,midy+1,x2,y2,p4);
 }
 /*---------------------------*/
 restore(int x1,int y1)
 {
 putimage(x1,y1,p1,OR_PUT);
 putimage(midx+1,y1,p2,OR_PUT);
 putimage(x1,midy+1,p3,OR_PUT);
 putimage(midx+1,midy+1,p4,OR_PUT);

 farfree(p1);
 farfree(p2);
 farfree(p3);
 farfree(p4);
 }
 /*-----------------*/




	  getmousepos(int *key,int *x,int *y)
	  /* Function to obtain the mouse position */

	  {
		a.x.ax=3;  /* set the service number */
		int86(0x33,&a,&b); /* call for interupt *./
		*key=b.x.bx;  /* status Up or Down */
		*x=b.x.cx;    /* x coordinate */
		*y=b.x.dx;    /* y coordinate */

	   }

/*---------------end of getmousepos function------------------------*/

	  initmouse()
	  /* function to initialise the mouse */

	  {
	   a.x.ax=0;
	   int86(0x33,&a,&b);
	   return(b.x.ax);
	   }

/*--------------end of initmouse function--------------------------*/

	  showmouseptr()
	  /* function to display the mouse position */
	  {
	    a.x.ax=1;
	    int86(0x33,&a,&b);
	  }

/*---------------end of function showmouseptr----------------------*/

hidemouseptr()
{
a.x.bx=2;
int86(0x33,&a,&b);
}
/*---------------*/
restrictmouseptr(int x1,int y1,int x2,int y2)
{
a.x.ax=7;
a.x.cx=x1;
a.x.dx=x2;
int86(0x33,&a,&b);
a.x.ax=8;
a.x.cx=y1;
a.x.dx=y2;
int86(0x33,&a,&b);
}